
#include "../API/LJClassifier.h"
//#include "../ICTClassifier/ICTClassifier.h"

#ifdef _DEBUG
#pragma comment(lib, "../../../bin/Classifier/LJClassifierD.lib")    // debugLJClassifierD.lib
#else
#pragma comment(lib, "../../../bin/Classifier/LJClassifier.lib")     // releaseLJClassifier.lib
#endif

#include <string>
#include <vector>
using namespace std;
#pragma warning(disable:4786)	

bool gfn_bSplit(const char* lpszText, vector<string>& vResult, const char* lpszDelimiter);
int main(int argc, char* argv[])
{

	if(!classifier_init("rulelist.xml")) {
		printf("classifier_init failed!\n");
		return 1;
	}

	stDoc d;
	d.sTitle = "ֻE600";  
	d.sContent = "ȫбر:ֻE600  2011-9-26 15:53ֻʹߵĵӲƷ,»ٶȸǿ޷ô߶,Ӧѡ? Ȼ,ƵĻǷǳ,֧,ƽ,ڹ֮Ӧѡһֻ..."; 

	d.sAuthor = "";
	d.sBoard = "69"; 
	d.sDatatype = "̳";

	string sResult = classifier_exec(d);
	printf("\n˽ %s\n\n", sResult.c_str());

	vector<string> vsItems;
	gfn_bSplit(sResult.c_str(), vsItems, "\t");

	for(int i=0; i<vsItems.size(); i++) {              //ڴ

		string sDetail = classifier_detail(vsItems[i].c_str());
		printf("ɣ %s\n", sDetail.c_str());

	}

	classifier_exit();	

	printf("Please input enter to quit...");
	getchar();

	return 0;
}

bool gfn_bSplit(const char* lpszText, vector<string>& vResult, const char* lpszDelimiter) {

	vResult.clear();

	int iOldSize = strlen(lpszText);
	if(!lpszText || (iOldSize==0))
		return false;

	int iDeSize = strlen(lpszDelimiter);
	if(!lpszDelimiter || (iDeSize==0)) {
		vResult.push_back(lpszText);
		return true;
	}//if

	char* pOccur = strstr((char*)lpszText, lpszDelimiter);
	if(!pOccur) {
		vResult.push_back(lpszText);
		return true;
	}

	int iSize = pOccur-lpszText;

	char* pSeg = new char[iOldSize+1];
	memset(pSeg, 0, iOldSize+1);

	pSeg = strncpy(pSeg, lpszText, iSize);

	if(strlen(pSeg) > 0) {
		vResult.push_back(pSeg);
	}//if

	pOccur += iDeSize;
	char* pOldOccur = pOccur;

	while(pOccur) {
		pOccur = strstr(pOccur, lpszDelimiter);
		if(!pOccur) {
			if(strlen(pOldOccur) > 0)
				vResult.push_back(pOldOccur);

			break;
		}

		iSize = pOccur - pOldOccur;
		memset(pSeg, 0, iOldSize+1);
		pSeg = strncpy(pSeg, pOldOccur, iSize);

		if(strlen(pSeg) > 0) {
			vResult.push_back(pSeg);
		}

		pOccur += iDeSize;
		pOldOccur = pOccur;
	}//while

	delete pSeg;

	return true;
}//gfn_bSplit


//// DemoDos.cpp : ̨Ӧóڵ㡣
////
//#include "../ICTClassifier/ICTClassifier.h"
//#include "ReadData.h"
//
//#pragma comment(lib, "../bin/LJClassifier.lib")
//
//typedef struct _stDocResult {
//
//    stDoc theDoc;
//	string sDetail;
//
//}stDocResult;
//
//time_t tBegin,tEnd;
//
//int main(int argc, char* argv[])
//{
//	//if (argc != 2){
//	//	printf("usage: DemoDos <TestDataDir>\n");
//	//	return 1;
//	//}
//
///*	if(!classifier_db_ruleread()) {
//		printf("classifier_db_ruleread failed!\n");
//		return 1;
//	}
//*/
//	if(!classifier_init("rulelist.xml", "LingJoinClassifier*~!@#%&&%#@!~*")) {
//        printf("classifier_init failed!\n");
//		return 1;
//	}
//
//	stDoc d;
//	d.sTitle = "8ͯ˿ AƬ 4Ůͯ";  
//	d.sContent = "ӦûýºӲҪɫƬԺӲ"; 
//
//	//d.sAuthor = "";
//	//d.sBoard = "69"; 
//	//d.sDatatype = "̳";
//
//	string sResult = classifier_exec(&d);
//	printf("%s\n", sResult.c_str());
//
//	vector<string> vsItems;
//	gfn_bSplit(sResult.c_str(), vsItems, " ");
//
//	for(int i=0; i<vsItems.size(); i++) {              //ڴ
//
//		string sDetail = classifier_detail(vsItems[i].c_str());
//		printf("%s\n", sDetail.c_str());
//
//	}
//
///*	stDoc d;
//	d.sTitle = "ɥһƭ";  
//	d.sContent = "иԴӵ֤ϯһֱµĿǰжҹ˾άȨϣߵԺ֤..֣֤Ӧñҵֻ֤ᱻȡԺ󣬹вǡ"; 
//	d.sContent = "  \
//	8156еǰʮ  \
//	  \
//	йƽ601318.SH627յ50Ԫйʽ޹˾³ơн𡱣Ϻ·֤ȯӪҵӰйƽƵƵûְ롢ϯλס\
//	Ϻ֤ȯϢʾӪҵ13770.3Ԫңͬйƽϯλ֮׵ͬʱ10638.02Ԫϯλ֮ףϼƾ3132.28ԪйƽɽΪ25.73Ԫ\
//	йƽڵµУӪҵӰƵƵûTopviewݣ627йƽ50Ԫ1028յ81УӪҵ56γйƽǰʮλ֮У5Ԫ10628գӪҵֳ״̬ۼƾӽ1.09Ԫ\
//	֤ȯҵоԱΪйƽͣӦòǻʲô仯ҪΪ󡣻Ľڿйƽǣ䳤Ʋ̫Ӱ졣гͶʽǶȿйƽǺܲġ\
//	йƽнΪĿı䶯ҪԴȱȽͶ񻯺ͶԸͨͶʼֵ׼ĿǰоʹֵѽӽʷײڻԽϾйHɣ02628.HK1.5оʷֵйƽɼµռ䡣\
//	׫ˣ\
//	֣һƾվݲΪͶ,ο,ݴ,Ե";
//	
//	d.sAuthor = "";
//	d.sBoard = "69"; 
//	d.sDatatype = "";
//
//	string sResult = classifier_exec(&d);
//	printf("%s\n", sResult.c_str());
//
//	vector<string> vsItems;
//	gfn_bSplit(sResult.c_str(), vsItems, " ");
//
//	for(int i=0; i<vsItems.size(); i++) {              //ڴ
//
//		string sDetail = classifier_detail(vsItems[i].c_str());
//		printf("%s\n", sDetail.c_str());
//	
//	}
//*/
//	//time(&tBegin);
//
//	//ReadData theReadData(argv[1]);
//	//vector<string> vsFolderName;
//	//theReadData.fn_vScanFolders(vsFolderName);
//
//	//for(int i=0; i<vsFolderName.size(); i++) {	
//	//	theReadData.fn_vScanXmlFiles(vsFolderName[i]);
//	//}
//
//	//gfn_bCleanDirectory("./output");
//
//	//int iDocCount = 0;
//	//string sLog;
//	//for(int i=0; i<theReadData.m_vsXmlFileName.size(); i++) {
//
//	//	sLog += theReadData.m_vsXmlFileName[i];
//	//	sLog += "\n";
//	//	gfn_bWriteFile("log.txt", sLog.c_str());
//	//	
//	//	list<stItem> theItems;
//	//	theReadData.fn_iGetItems(theItems, theReadData.m_vsXmlFileName[i]);
//
//	//	string sTextFileName = theReadData.m_vsXmlFileName[i];
//	//	gfn_vReplaceSubstr(sTextFileName, ".xml", ".txt");
//
//	//	FILE* fp = fopen(sTextFileName.c_str(), "rb");
//	//	if(!fp)
//	//		continue;
//
//	//	list<stItem>::iterator it = theItems.begin();
//	//	for(; it!=theItems.end(); it++) {
//
//	//		stDoc d;
//	//		d.sTitle = it->sTitle;
//	//		d.sAuthor = it->sAuthor;
//	//		char buf[MAX_FILE_PATH];
//	//		itoa(it->iBoardcode, buf, 10);			
//	//		d.sBoard = buf;
//	//		itoa(it->iGroupid, buf, 10);		
//	//		d.sDatatype = buf;
//
//	//		gfn_bReadFile(sTextFileName.c_str(), d.sContent);
//
//	//		long lTxtlen = it->iTxtlen;
//	//		long lOffset = it->i64Txtoffset;
//
//	//		char* lpszFileText = (char*)calloc(lTxtlen+1, sizeof(char));
//	//		if(!lpszFileText) {
//	//			fclose(fp);
//	//			return false;
//	//		}
//
//	//		memset(lpszFileText, 0, lTxtlen+1);
// //
// //           fseek(fp, lOffset, SEEK_SET);
//	//		fread(lpszFileText, sizeof(char), lTxtlen,fp);
//
//	//		d.sContent = lpszFileText;
//	//		free(lpszFileText);                                //Ƕȡcacheÿһ    
//
//	//		string sResult = classifier_exec(&d, 1);
//	//		printf("%d: %s\n", iDocCount++, sResult.c_str());		
//
//	//		vector<string> vsItems;
//	//		gfn_bSplit(sResult.c_str(), vsItems, "\t");
//
//	//		for(int i=0; i<vsItems.size(); i++) {              //ڴ
//
//	//			vector<string> vsItem2;
//	//			gfn_bSplit(vsItems[i].c_str(), vsItem2, " ");
//	//			if(vsItem2.size() != 2)
//	//				continue;
//
//	//			string sTextFileName = "./output/" + vsItem2[0] + ".xml";
//	//			string sTextContent = "";
//	//			sTextContent += "<doc>\n\t<title>";
//	//			sTextContent += d.sTitle;
//	//			sTextContent += "</title>\n\t<author>";
//	//			sTextContent += d.sAuthor;
//	//			sTextContent += "</author>\t<board>";
//	//			sTextContent += d.sBoard;
//	//			sTextContent += "</board>\t<datatype>";
//	//			sTextContent += d.sDatatype;
//	//			sTextContent += "</datatype>\n\t<certainty>";
//	//			sTextContent += vsItem2[1];
//	//			sTextContent += "</certainty>\n\t<ruledetail>\n";
//	//			sTextContent += classifier_detail(vsItem2[0].c_str());		
//	//			sTextContent += "\t</ruledetail>\n\t<content>\n";
//	//			sTextContent += d.sContent;
//	//			sTextContent += "\n\t</content>\n</doc>\n\n";
//	//			FILE* fp1 = fopen(sTextFileName.c_str(), "a+");
//	//			if(!fp1) continue;
//	//			fprintf(fp1, "%s", sTextContent.c_str());
//	//			fclose(fp1);
//	//			
//	//		}
//
//	//	}
//
//	//	fclose(fp);
//
//	//}
//
//	//sLog += "[End]\nTotal Count: ";
//	//char buf[MAX_FILE_PATH];
//	//itoa(iDocCount, buf, 10);
//	//sLog += buf;
//
//	//time(&tEnd);
//	//double fDiff = difftime(tEnd, tBegin);
//	//char sDiff[10];
//	//sprintf(sDiff, "%.1f", fDiff);
//
//	//sLog += "\nTime: ";
//	//sLog += sDiff;
//
//	//gfn_bWriteFile("log.txt", sLog.c_str());
//
//
//	classifier_exit();	
//
//	printf("Please input enter to quit...");
//	getchar();
//	
//	return 0;
//}
//
